<template>
  <el-main>
    <el-form ref="form" :model="form" label-width="130px">
      <h2 style="text-align: center;font-weight: bold;font-size: 20px">制作人</h2>
      <el-row>
        <el-col :span="12">
          <el-form-item label="执法人1">
            <el-input v-model="form.name"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="执法证号">
            <el-input v-model="form.name"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="执法人2">
            <el-input v-model="form.name"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="执法证号">
            <el-input v-model="form.name"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="制作方法">
        <el-input type="textarea" :row="2" placeholder="制作方法" v-model="form.name"></el-input>
      </el-form-item>
      <el-form-item label="备注">
        <el-input type="textarea" :row="2" placeholder="备注" v-model="form.name"></el-input>
      </el-form-item>
      <h2 style="text-align: center;font-weight: bold;font-size: 20px">记录拍摄内容</h2>
      <div v-for="(item,index) in form.shotCertents" :key="index">
        <el-form-item label="记录内容">
          <el-input type="textarea" :row="2" placeholder="记录内容" v-model="item.centers"></el-input>
        </el-form-item>
        <el-form-item label="证明事项">
          <el-input type="text" placeholder="证明事项" v-model="item.name"></el-input>
        </el-form-item>
        <el-row>
          <el-col :span="12">
            <el-form-item label="时间节点">
              <el-input v-model="item.stateTime"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="拍摄时间">
              <el-date-picker
                v-model="item.shotTime"
                type="datetime"
                placeholder="拍摄时间">
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
        <el-form-item label="拍摄地点">
          <el-input type="text" placeholder="拍摄地点" v-model="item.adders"></el-input>
        </el-form-item>
      </div>
      <el-form-item label-width="50%">
        <el-button type="text" @click="addEle">
          <img src="../../../../assets/lawImg/addIcon.png" alt="">
        </el-button>
      </el-form-item>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center">
      <el-button v-if="isFinish!='2'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="isFinish!='2'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import {getObj, saveObj} from "@/api/News/frenchVideoAudio";
import WordView from "@/views/News/word-view";

export default {
  name: "frenchVideoAudio",
  props: ['isShowYulan', 'id', 'isFinish', 'processId', 'title'],
  components: {
    WordView
  },
  data() {
    return {
      showView: false,
      form: {
        unitName: "",
        light: "",
        name: '',
        shotTime: "",
      }
    }
  },
  methods: {
    init() {
      getObj(this.id).then((res) => {
        // 转换null为""
        let v = res.data.data;
        for (let attr in v) {
          if (v[attr] == null) {
            v[attr] = "";
          }
        }
        let str = JSON.stringify(v);
        let data = JSON.parse(str);
        this.form = data;
      });
    },
    dataFormSubmit(type) {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success('操作成功');
                obj.cancel();
                obj.$emit('getDataList');
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              obj.$message.success("操作成功");
              obj.cancel();
              obj.$emit('getDataList');
            })
          }
        }
      })
    },
    // 点击添加
    addEle() {
      this.form.shotCertents.push({
        name: "",
        centers: "",
        stateTime: "",
        shotTime: "",
        adders: "",
      });
    },
    cancell(e, d) {
      this.isShow = e;
      if (d != undefined) {
        this.form.goodsDis.push(d)
      }
    },
    viewVord(data) {
      if (data.registerState == null || data.registerState == "") {
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/saveproofDisposeInform.docx");
      })
    },
    downloadWord(data) {
      if (data.registerState == null || data.registerState == "") {
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/saveproofDisposeInform.docx", this.title + '.docx');
    },
  }
}
</script>

<style scoped>

</style>
